$missionVersion = "1.5.3";
$missionName    = "\"Budda Castle\"";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
exec("BoPstdlib.cs");

$BOP::BoPMap = true;

function mapOnMissionStart() { 
  temperateSounds();
}

// meteor start area
$MS_xmin = $ME_xmin - 2000;
$MS_ymin = $ME_ymin - 2000;
$MS_xmax = $ME_xmax + 2000;
$MS_ymax = $ME_ymax + 2000;

// meteor end area
$ME_xmin = 276;
$ME_ymin = 308;
$ME_xmax = 812;
$ME_ymax = 844;

$showerInterval = 60;
function budda::structure::onAttacked(%this, %object) { 
  %player = playerManager::vehicleIdToPlayerNum(%object);
  if(%player == 0) {
    return;
  }
  %player.name = getName(%object);
  %now = getCurrentTime();
  // has it been too soon since last shower ?
  if ( %player.lastShower ) { 
    %diff = %now - %player.lastShower;
    if ( %diff < $showerInterval ) {
      say(%player,0,"<F0>Only one meteor shower per minute!"); 
      return;
    } else { 
      say(%player,0,"<F0>You have displeased Budda!  Prepare for my wrath.");
      randomDeathStorm();
      setHudTimer($showerInterval,-1,"Shower Timer",3,%player);
    }
  } else { 
    say(%player,0,"<F0>You have displeased Budda! Prepare for my wrath.");
    randomDeathStorm();
    setHudTimer($showerInterval,-1,"Shower Timer",3,%player);
  }
  echo ( strcat("==> Setting " , %player.name , "'s last shower time to " , %now , "." ));
  %player.lastShower = %now;
}

$buddaInterval = 60;
function budda::trigger::onEnter(%this, %object) { 
  %player = playerManager::vehicleIdToPlayerNum(%object);
  if(%player == 0) {
    return;
  }
  if ( %object.lastBudda ) { 
    %last = %object.lastBudda;
  } else {
    %last = 0;
  }
  %now = getCurrentTime();
  %diff = %now - %last;
  if ( %diff < $buddaInterval ) { 
    echo ( "not ready yet" );
    say(%player,0,"<F1>Budda not happy again yet.");
    return;
  }
  say(%player,0,"<F1>Budda welcomes you.");
  healObject(%object,1000000);
  reloadObject(%object,1000000);
  setHudTimer($buddaInterval,-1,"Budda Zen Timer",2,%player);
  %object.lastBudda = %now;
}

function randomDeathStorm(){
  Say(0, 0, "WARNING:  Meteor shower detected!");
  dropMeteor("default", 1, 3,$MS_xmin, $MS_ymin, $MS_xmax, $MS_ymax, $ME_xmin, $ME_ymin, $ME_xmax, $ME_ymax);
  %dropMeteors = "dropMeteor(\"default\", 1, 3, $MS_xmin, $MS_ymin, $MS_xmax, $MS_ymax, $ME_xmin, $ME_ymin, $ME_xmax, $ME_ymax);";
  schedule(%dropMeteors, 4);
  schedule(%dropMeteors, 8);
  schedule(%dropMeteors, 12);
  schedule(%dropMeteors, 16);
  schedule(%dropMeteors, 20);
  schedule(%dropMeteors, 24);
  schedule(%dropMeteors, 28);
  schedule(%dropMeteors, 32);
  schedule(%dropMeteors, 36);
}

function ToDungeon::trigger::onEnter(%this, %vehicleId) { 
  %dest[0] = "MissionGroup\\Dests\\Dungeon0";
  %dest[1] = "MissionGroup\\Dests\\Dungeon1";
  %dest[2] = "MissionGroup\\Dests\\Dungeon2";
  %dest[3] = "MissionGroup\\Dests\\Dungeon3";
  %dest[4] = "MissionGroup\\Dests\\Dungeon4";
  %dest[5] = "MissionGroup\\Dests\\Dungeon5";
  %dest[6] = "MissionGroup\\Dests\\Dungeon6";
  %dest[7] = "MissionGroup\\Dests\\Dungeon7";
  %dest[8] = "MissionGroup\\Dests\\Dungeon8";
  $index = randomInt(0,8);
  echo($index);
  %tmp = %dest[$index];
  echo(%tmp);
  %player = playerManager::vehicleIdToPlayerNum(%vehicleID);
  if(%player == 0) {
    return;
  }
  metaWarp(%vehicleID,%tmp);
}

function ToYellowBase::trigger::onEnter(%this, %vehicleId) {
  %tmp = "MissionGroup\\Dests\\YellowBase";
  WARP::transV(%vehicleId, %tmp, 10);
}	

function ToRedBase::trigger::onEnter(%this, %vehicleId) {
  %tmp = "MissionGroup\\Dests\\RedBase";
  WARP::transV(%vehicleId, %tmp, 10);
}	

function ToBlueBase::trigger::onEnter(%this, %vehicleId) {
  %tmp = "MissionGroup\\Dests\\BlueBase";
  WARP::transV(%vehicleId, %tmp, 10);
}	

function ToPurpleBase::trigger::onEnter(%this, %vehicleId) {
  %tmp = "MissionGroup\\Dests\\PurpleBase";
  WARP::transV(%vehicleId, %tmp, 10);
}	
